## kdb 3.2.0

=== autotests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_KEYWORDS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_CAST_FROM_ASCII
    -DQT_USE_QSTRINGBUILDER
)

set(FILES_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(KDB_LOCAL_PLUGINS_DIR ${PROJECT_BINARY_DIR}/plugins)
add_definitions(
    -DFILES_OUTPUT_DIR=\"${FILES_OUTPUT_DIR}\"
     # make plugins work without installing them:
    -DKDB_LOCAL_PLUGINS_DIR=\"${KDB_LOCAL_PLUGINS_DIR}\"
     # nonstandard path for sqlite3 extensions, they would work too if we placed them
     # in ${KDB_LOCAL_PLUGINS_DIR}/sqlite3 but we want to test the "extraSqliteExtensionPaths"
     # connection option in ConnectionTest::testCreateDb():
    -DSQLITE_LOCAL_ICU_EXTENSION_PATH=\"${KDB_LOCAL_PLUGINS_DIR}/sqlite3\"
    -DYYTOKENTYPE # this removes access to yytokentype enum as we should access KDb::Token instead
)

include(ECMAddTests)

find_package(Qt5Test)
set_package_properties(Qt5Test PROPERTIES DESCRIPTION "Qt5Test library"
                       URL "https://www.qt.io" TYPE RECOMMENDED
                       PURPOSE "Required by tests")

# A helper library for db-related tests
add_library(kdbtestutils SHARED
    KDbTestUtils.cpp
)
target_link_libraries(kdbtestutils
    PUBLIC
        KDb
        Qt5::Test
)
generate_export_header(kdbtestutils)

# Tests
ecm_add_tests(
    ConnectionOptionsTest.cpp
    ConnectionTest.cpp
    DateTimeTest.cpp
    DriverTest.cpp
    ExpressionsTest.cpp
    MissingTableTest.cpp
    OrderByColumnTest.cpp
    QuerySchemaTest.cpp
    KDbTest.cpp

    LINK_LIBRARIES
        kdbtestutils
)

target_compile_definitions(MissingTableTest PRIVATE -DFILES_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )

target_compile_definitions(OrderByColumnTest PRIVATE KDB_DEPRECATED=)

if(NOT WIN32) #TODO enable for Windows when headers_test.sh is ported e.g. to python
    add_subdirectory(headers)
endif()
add_subdirectory(tools)
add_subdirectory(parser)

=== src/CMakeLists.txt ===
# Private options (visible only within KDb)
simple_option(KDB_EXPRESSION_DEBUG "Debugging of Expression classes" OFF)
simple_option(KDB_DRIVERMANAGER_DEBUG "Debugging of the Driver Manager class" OFF)
simple_option(KDB_TRANSACTIONS_DEBUG "Debugging of the Transaction class" OFF)
simple_option(KDB_TABLESCHEMACHANGELISTENER_DEBUG "Debugging of the KDbTableSchemaChangeListener class" OFF)
simple_option(KDB_QUERYSCHEMA_DEBUG "Debugging of the QuerySchema class" OFF)
simple_option(KDB_SQLPARSER_DEBUG "Debugging of the SQL parser" OFF)

# Public options (affecting public behavior or contents of KDb)
simple_option(KDB_DEBUG_GUI "GUI for debugging" OFF)
# NOTE: always add public options to KDbConfig.cmake.in as well

include(CheckIncludeFile)
check_include_file(unistd.h HAVE_UNISTD_H)

#add_definitions(
#    TODO  -DKDE_DEFAULT_DEBUG_AREA=44000
#)

########### generate parser/lexer files ###############
# as described at https://public.kitware.com/pipermail/cmake/2002-September/003028.html

# Create target for the parser
add_custom_target(parser echo "Creating parser/lexer files")

set(PARSER_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/parser)

# Create custom command for flex/lex (note the outputs)
# TODO(GEN) uncomment GENERATED if we ever use this patch: https://phabricator.kde.org/D357 "No more generated parser/scanner files in the source dir"
add_custom_command(
    TARGET parser
    COMMAND ${PARSER_SOURCE_DIR}/generate_parser_code.sh
    DEPENDS ${PARSER_SOURCE_DIR}/KDbSqlParser.y
            ${PARSER_SOURCE_DIR}/KDbSqlScanner.l
            ${PARSER_SOURCE_DIR}/generate_parser_code.sh
    OUTPUT
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlparser.h
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlparser.cpp
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlscanner.cpp
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/KDbToken.h
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/KDbToken.cpp
)

if(NOT HAVE_UNISTD_H)
    set(EXTRA_SCANNER_COMPILE_FLAGS "-DYY_NO_UNISTD_H=1")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    set(EXTRA_SCANNER_COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} -Wno-sign-compare -Wno-unused-function -Wno-deprecated-register -Wno-zero-as-null-pointer-constant")
elseif(MSVC)
    set(EXTRA_SCANNER_COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} /wd4018") # disable warning C4018: '<' : signed/unsigned mismatch
endif()

# Mark files as generated, set compile flags
set_source_files_properties(${PARSER_SOURCE_DIR}/generated/sqlparser.cpp
    PROPERTIES
        #TODO(GEN) GENERATED TRUE
        SKIP_AUTOMOC ON
        # YYERROR_VERBOSE=1 needed to get a token table for tokenName() even for release builds
        COMPILE_FLAGS "-DYYERROR_VERBOSE=1 ${EXTRA_PARSER_COMPILE_FLAGS} "
)
# TODO(GEN) set_source_files_properties(${PARSER_SOURCE_DIR}/generated/sqlparser.h PROPERTIES GENERATED TRUE)
# TODO(GEN) set_source_files_properties(${PARSER_SOURCE_DIR}/generated/KDbToken.h PROPERTIES GENERATED TRUE)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/KDbConnectionData_sdc.cpp
    PROPERTIES
        GENERATED TRUE
        SKIP_AUTOMOC ON
)

set_source_files_properties(
    ${PARSER_SOURCE_DIR}/generated/sqlscanner.cpp
    PROPERTIES
        #TODO(GEN) GENERATED TRUE
        SKIP_AUTOMOC ON
        COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} "
)

set(kdb_LIB_SRCS
   parser/generated/sqlscanner.cpp
   parser/generated/sqlparser.cpp
   parser/generated/KDbToken.cpp
   parser/KDbParser.cpp
   parser/KDbParser_p.cpp
   parser/KDbSqlParser.y
   parser/KDbSqlScanner.l
   parser/generate_parser_code.sh
   parser/extract_tokens.sh
   parser/TODO

   tools/KDbJsonTrader_p.cpp # mostly copied from KReport's KReportJsonTrader_p.cpp
   tools/KDbValidator.cpp
   tools/KDbFieldValidator.cpp
   tools/KDbLongLongValidator.cpp
   tools/KDbObjectNameValidator.cpp
   tools/KDbIdentifierValidator.cpp
   tools/KDbUtils.cpp
   #TODO tools/debuggui.cpp
   #TODO tools/KDbSimpleCommandLineApp.cpp

   tools/transliteration/transliteration_table.cpp
   tools/transliteration/generate_transliteration_table.sh
   tools/transliteration/transliteration_table.readme

   KDbDateTime.cpp
   KDbEscapedString.cpp
   KDbResult.cpp
   KDbQueryAsterisk.cpp
   KDbConnectionData.cpp
   KDbVersionInfo.cpp
   ${CMAKE_CURRENT_BINARY_DIR}/KDbConnectionData_sdc.cpp
   KDbField.cpp
   KDbQuerySchemaParameter.cpp
   expression/KDbExpression.cpp
   expression/KDbNArgExpression.cpp
   expression/KDbUnaryExpression.cpp
   expression/KDbBinaryExpression.cpp
   expression/KDbConstExpression.cpp
   expression/KDbQueryParameterExpression.cpp
   expression/KDbVariableExpression.cpp
   expression/KDbFunctionExpression.cpp
   KDbFieldList.cpp
   KDbTableSchema.cpp
   KDbTableSchemaChangeListener.cpp
   KDbIndexSchema.cpp
   KDbOrderByColumn.cpp
   KDbQuerySchema.cpp
   KDbQuerySchema_p.cpp
   KDbQueryColumnInfo.cpp
   KDbTableOrQuerySchema.cpp
   KDbDriverManager.cpp
   KDbDriver.cpp
   KDbDriver_p.cpp
   KDbDriverMetaData.cpp
   KDbConnection.cpp
   KDbConnectionProxy.cpp
   generated/sqlkeywords.cpp
   KDbObject.cpp
   KDb.cpp
   KDbRecordData.cpp
   KDbCursor.cpp
   KDbTransaction.cpp
   KDbGlobal.cpp
   KDbRelationship.cpp
   KDbRecordEditBuffer.cpp
   KDbMessageHandler.cpp
   KDbPreparedStatement.cpp
   KDbProperties.cpp
   KDbAdmin.cpp
   KDbLookupFieldSchema.cpp
   KDbAlter.cpp
   KDbNativeStatementBuilder.cpp
   kdb_debug.cpp

   views/KDbTableViewData.cpp
   views/KDbTableViewColumn.cpp
   views/chartable.txt

   sql/KDbSqlField.cpp
   sql/KDbSqlRecord.cpp
   sql/KDbSqlResult.cpp

   # private:
   tools/KDbUtils_p.h

   # non-source:
   Mainpage.dox
   Messages.sh
)

ecm_create_qm_loader(kdb_LIB_SRCS kdb_qt)

add_library(KDb SHARED ${kdb_LIB_SRCS})
set_coinstallable_lib_version(KDb)

kdb_create_shared_data_classes(
    kdb_GENERATED_SHARED_DATA_CLASS_HEADERS # output variable with list of headers
    NO_PREFIX # subdirectory in which the headers should be generated
    KDbConnectionData.shared.h
    KDbObject.shared.h
    KDbQuerySchemaParameter.shared.h
    KDbResult.shared.h
    KDbSelectStatementOptions.shared.h
    KDbVersionInfo.shared.h
)

kdb_remove_extensions(
    kdb_GENERATED_SHARED_DATA_CLASS_BASENAMES
    ${kdb_GENERATED_SHARED_DATA_CLASS_HEADERS}
)

#message(STATUS "kdb_GENERATED_SHARED_DATA_CLASS_HEADERS: ${kdb_GENERATED_SHARED_DATA_CLASS_HEADERS}")

#add_dependencies(KDb _shared_classes) # generate shared classes before they can be used in KDb

generate_export_header(KDb)

set(kdb_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/expression
    ${CMAKE_CURRENT_SOURCE_DIR}/interfaces
    ${CMAKE_CURRENT_SOURCE_DIR}/parser
    ${CMAKE_CURRENT_SOURCE_DIR}/parser/generated
    ${CMAKE_CURRENT_SOURCE_DIR}/sql
    ${CMAKE_CURRENT_SOURCE_DIR}/tools
    ${CMAKE_CURRENT_SOURCE_DIR}/views
)

target_include_directories(KDb
    PUBLIC "$<BUILD_INTERFACE:${kdb_INCLUDE_DIRS}>"
    INTERFACE "$<INSTALL_INTERFACE:${KDB_INCLUDE_INSTALL_DIR}>"
)

target_link_libraries(KDb
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        KF5::CoreAddons
    PRIVATE
        Qt5::Xml
        ICU::i18n
)

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
if("${CMAKE_BUILD_TYPE_LOWER}" MATCHES "debug")
   target_compile_definitions(KDb PRIVATE -DYYDEBUG=1) # needed where sqlparser.h is used
endif()

set(QT_ISODATEWITHMS_MIN_VERSION 5.8.0)
if(Qt5_VERSION VERSION_LESS ${QT_ISODATEWITHMS_MIN_VERSION})
    message(STATUS "Qt ${Qt5_VERSION} does not have Qt::ISODateWithMs APIs, minimal version is \
${QT_ISODATEWITHMS_MIN_VERSION}. KDb's implementation will be compiled-in.")
else()
    # Qt::ISODateWithMs APIs present
    target_compile_definitions(KDb PRIVATE -DHAVE_QT_ISODATEWITHMS)
endif()

if(BUILD_TEST_COVERAGE)
    target_link_libraries(KDb
        PRIVATE
            gcov
    )
endif()

# Create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${CMAKECONFIG_INSTALL_PREFIX}/${KDB_BASE_NAME}")

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KDB
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdb_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDbConfigVersion.cmake"
)

install(TARGETS KDb
        EXPORT KDbTargets
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDbConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KDbConfig.cmake"
    INSTALL_DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
)

install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDbConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDbConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel)

install(EXPORT KDbTargets
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        FILE KDbTargets.cmake)

ecm_generate_pri_file(
    BASE_NAME ${KDB_BASE_NAME}
    LIB_NAME ${KDB_BASE_NAME}
    DEPS "widgets xml"
    FILENAME_VAR PRI_FILENAME
    INCLUDE_INSTALL_DIR ${KDB_INCLUDE_INSTALL_DIR}
)

install(FILES ${PRI_FILENAME}
        DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kdb_version.h"
        DESTINATION "${KDB_INCLUDE_INSTALL_DIR}"
        COMPONENT Devel)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    HEADER_NAMES
        KDb
        KDbAdmin
        KDbAlter
        KDbQueryAsterisk
        KDbConnection
        KDbConnectionOptions
        KDbConnectionProxy
        KDbCursor
        KDbDateTime
        KDbDriver
        KDbDriverBehavior
        KDbDriverManager
        KDbDriverMetaData
        KDbError
        KDbEscapedString
        KDbField
        KDbFieldList
        KDbGlobal
        KDbIndexSchema
        KDbLookupFieldSchema
        KDbMessageHandler
        KDbNativeStatementBuilder
        KDbPreparedStatement
        KDbProperties
        KDbQueryColumnInfo
        KDbOrderByColumn
        KDbQuerySchema
        KDbRecordData
        KDbRecordEditBuffer
        KDbRelationship
        KDbTableOrQuerySchema
        KDbTableSchema
        KDbTableSchemaChangeListener
        KDbTransaction
        KDbTransactionData
        KDbTransactionGuard
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE expression
    HEADER_NAMES
        KDbExpression
        KDbExpressionData
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE interfaces
    HEADER_NAMES
        KDbPreparedStatementInterface
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE parser
    HEADER_NAMES
        KDbParser
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE parser/generated
    HEADER_NAMES
        KDbToken
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE sql
    HEADER_NAMES
        KDbSqlField
        KDbSqlRecord
        KDbSqlResult
        KDbSqlString
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE views
    HEADER_NAMES
        KDbTableViewData
        KDbTableViewColumn
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE tools
    HEADER_NAMES
        KDbValidator
        KDbUtils
        KDbTristate
        #todo KDbSimpleCommandLineApp
        KDbLongLongValidator
        KDbIdentifierValidator
        KDbFieldValidator
        KDbObjectNameValidator
)

#message(STATUS "%% ${kdb_GENERATED_SHARED_DATA_CLASS_BASENAMES}")

ecm_generate_headers(kdb_FORWARDING_HEADERS_FROM_BUILDDIR
    REQUIRED_HEADERS kdb_HEADERS_FROM_BUILDDIR
    ORIGINAL CAMELCASE
    SOURCE_DIR ${PROJECT_BINARY_DIR}/src
    HEADER_NAMES

=== tools/CMakeLists.txt ===
add_custom_target(update_recommended_sqlite_ver echo "Updating recommended version of SQLite")

add_custom_command(
    TARGET update_recommended_sqlite_ver
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/update_recommended_sqlite_ver.sh
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== autotests/tools/CMakeLists.txt ===
ecm_add_tests(
    IdentifierTest.cpp
    StaticSetOfStringsTest.cpp
    UtilsTest.cpp

    LINK_LIBRARIES KDb Qt5::Test
)

=== src/drivers/CMakeLists.txt ===
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0005 NEW)
endif()

#TODO  add_definitions(-DKDE_DEFAULT_DEBUG_AREA=44001)

set(KDB_PLUGIN_INSTALL_DIR ${PLUGIN_INSTALL_DIR}/${KDB_BASE_NAME_LOWER})

# -----------------------
macro(build_and_install_kdb_driver _name _srcs _extra_libs)
    set(_target kdb_${_name}driver)
    ecm_create_qm_loader(_srcs ${_target}_qt)
    add_library(${_target} MODULE ${_srcs})

    target_link_libraries(${_target}
        PUBLIC
            KDb
        PRIVATE
            ${_extra_libs}
    )
    # Needed for examples and autotests:
    set_target_properties(${_target}
                          PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/${KDB_BASE_NAME_LOWER}")
    install(TARGETS ${_target} DESTINATION ${KDB_PLUGIN_INSTALL_DIR})
endmacro()
# -----------------------

# find SQLite:
set(SQLITE_MIN_VERSION 3.6.16)
set(SQLITE_RECOMMENDED_VERSION 3.27.1)
set(SQLITE_LOAD_EXTENSION_REQUIRED ON)
set(BUILD_SQLITE_DB_DRIVER_DESC "SQLite database driver")
find_package(Sqlite ${SQLITE_MIN_VERSION})
set_package_properties(Sqlite PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_SQLITE_DB_DRIVER_DESC}")

if(Sqlite_FOUND)
    ecm_optional_add_subdirectory(sqlite)
else()
    add_feature_info(BUILD_SQLITE_DB_DRIVER FALSE "${BUILD_SQLITE_DB_DRIVER_DESC} (because SQLite3 not found)")
    message(STATUS "WARNING: Because of that ${BUILD_SQLITE_DB_DRIVER_DESC} will not be built.")
endif()

# -----------------------

set(BUILD_MYSQL_DB_DRIVER_DESC "MySQL database driver")
find_package(MySQL)
set_package_properties(MySQL PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_MYSQL_DB_DRIVER_DESC}")
if(MySQL_FOUND)
   ecm_optional_add_subdirectory(mysql)
else()
   add_feature_info(BUILD_MYSQL_DB_DRIVER FALSE "${BUILD_MYSQL_DB_DRIVER_DESC} (because MySQL Client Library not found)")
endif()

# -----------------------

set(BUILD_POSTGRESQL_DB_DRIVER_DESC "PostgreSQL database driver")
find_package(PostgreSQL)
set_package_properties(PostgreSQL PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_POSTGRESQL_DB_DRIVER_DESC}")
if(PostgreSQL_FOUND)
   ecm_optional_add_subdirectory(postgresql)
else()
   add_feature_info(BUILD_POSTGRESQL_DB_DRIVER FALSE "${BUILD_POSTGRESQL_DB_DRIVER_DESC} (because C API to PostgreSQL not found)")
endif()

#set(BUILD_SYBASE_DB_DRIVER_DESC "Sybase/MSSQL database driver")
#find_package(FreeTDS)
#set_package_properties(FreeTDS PROPERTIES
#                       DESCRIPTION "Open source implementation of the TDS (Tabular Data Stream) protocol"
#                       URL "https://www.freetds.org"
#                       TYPE OPTIONAL
#                       PURPOSE "Required by ${BUILD_SYBASE_DB_DRIVER_DESC}"
#)
#if(FreeTDS_FOUND)
#   ecm_optional_add_subdirectory(sybase)
#else()
#   add_feature_info(BUILD_SYBASE_DB_DRIVER FALSE "${BUILD_SYBASE_DB_DRIVER_DESC} (because FreeTDS protocol implementation not found)")
#endif()

#set(BUILD_XBASE_DB_DRIVER_DESC "xBase database driver")
#find_package(XBase)
#set_package_properties(XBase PROPERTIES
#                       DESCRIPTION "XBase compatible C++ class library"
#                       URL "https://linux.techass.com/projects/xdb"
#                       TYPE OPTIONAL
#                       PURPOSE "Required by ${BUILD_XBASE_DB_DRIVER_DESC}"
#)
#if(XBASE_FOUND)
#   ecm_optional_add_subdirectory(xbase)
#else()
#   add_feature_info(BUILD_XBASE_DB_DRIVER FALSE "${BUILD_XBASE_DB_DRIVER_DESC} (because XBase compatible C++ class library not found)")
#endif()

=== src/drivers/mysql/CMakeLists.txt ===
add_feature_info(BUILD_MYSQL_DB_DRIVER TRUE ${BUILD_MYSQL_DB_DRIVER_DESC})

include_directories(
  ${MYSQL_INCLUDE_DIR}
)

set(kdb_mysqldriver_SRCS
    mysql_debug.cpp
    MysqlDriver.cpp
    MysqlConnection.cpp
    MysqlConnection_p.cpp
    MysqlCursor.cpp
    MysqlKeywords.cpp
    MysqlPreparedStatement.cpp
    kdb_mysqldriver.json
)

build_and_install_kdb_driver(mysql "${kdb_mysqldriver_SRCS}" "${MYSQL_LIBRARIES}")

=== src/drivers/xbase/CMakeLists.txt ===
add_feature_info(BUILD_XBASE_DB_DRIVER TRUE ${BUILD_XBASE_DB_DRIVER_DESC})

include_directories(
  ${XBase_INCLUDE_DIR}
)

set(kdb_xbasedriver_SRCS
   XbaseDriver.cpp
   XbaseConnection.cpp
   XbaseConnection_p.cpp
   XbaseCursor.cpp
   XbaseKeywords.cpp
   XbaseExport.cpp
   kdb_xbasedriver.json
)

build_and_install_kdb_driver(xbase "${kdb_xbasedriver_SRCS}" "${XBase_LIBRARIES}")

=== src/drivers/sqlite/icu/CMakeLists.txt ===
add_library(kdb_sqlite_icu MODULE icu.cpp sqliteicu.h README.txt)

generate_export_header(kdb_sqlite_icu)

target_link_libraries(kdb_sqlite_icu
    PRIVATE
        ${SQLITE_LIBRARIES}
        ICU::i18n
        ICU::uc
)
set_target_properties(kdb_sqlite_icu PROPERTIES
                      PREFIX ""
                      # nonstandard path for sqlite3 extensions, they would work too if we placed them
                      # in ${PROJECT_BINARY_DIR}/plugins/kdb/sqlite3 but we want to test the "extraSqliteExtensionPaths"
                      # connection option in ConnectionTest::testCreateDb():
                      LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/${KDB_BASE_NAME_LOWER}/sqlite3"
                      DEFINE_SYMBOL kdb_sqlite_icu_EXPORTS)

install(TARGETS kdb_sqlite_icu
        DESTINATION ${KDB_PLUGIN_INSTALL_DIR}/sqlite3) # Use a subdir for clarity

=== debian/changelog ===
kdb (3.2.0-9) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Pass -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to cmake so it builds with cmake 4
    (hoping that everything works properly). (Closes: #1113069)
  * Tweak watch file so it works with newer versions of uscan.

 -- Pino Toscano <pino@debian.org>  Mon, 06 Oct 2025 20:05:38 +0200

kdb (3.2.0-8) unstable; urgency=medium

  * Backport upstream commit f32e5c03d18977d32b1eb5df2deb2a908ff4780c to use
    C++17 to build; patch upstream_Fix-build-with-newer-ICU.patch.
    (Closes: #1092345)
  * Update symbols file.

 -- Pino Toscano <pino@debian.org>  Wed, 05 Feb 2025 19:21:58 +0100

kdb (3.2.0-7) unstable; urgency=medium

  * Drop the unused libpqxx-dev build dependency.
  * Update standards version to 4.7.0, no changes needed.
  * Switch the transitional pkg-config build dependency to pkgconf.

 -- Pino Toscano <pino@debian.org>  Wed, 01 May 2024 09:13:18 +0200

kdb (3.2.0-6) unstable; urgency=medium

  * CI: enable the blhc job again.
  * Bump Standards-Version to 4.6.1, no changes required.
  * Backport upstream commit 3a31ad05fcc7682bf3b65143af99fdb9b2e1e248 to fix the
    build with newer Qt 5.12.x; patch upstream_Fix-build-with-newer-Qt.patch.
    (Closes: #1013562)

 -- Pino Toscano <pino@debian.org>  Sun, 03 Jul 2022 07:49:01 +0200

kdb (3.2.0-5) unstable; urgency=medium

  * Change the python3 build dependency to python3:any, as Python is needed
    only as build tool.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper build dependency to debhelper-compat 13
    - remove debian/compat
    - stop passing --fail-missing to dh_missing, as it is the default behaviour
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version to 4.6.0, no changes required.
  * Update symbols file.
  * CI: disable the blhc job.

 -- Pino Toscano <pino@debian.org>  Thu, 23 Sep 2021 08:03:43 +0200

kdb (3.2.0-4) unstable; urgency=medium

  * Small copyright update.
  * Use the Debian postgresql-common stuff to force the default version of
    PostgreSQL:
    - invoke /usr/share/postgresql-common/supported-versions, getting the
      default version of it
    - pass -DPostgreSQL_ADDITIONAL_VERSIONS to cmake
    - drop patch upstream_cmake-find-PostgreSQL-12.patch, no more needed now

 -- Pino Toscano <pino@debian.org>  Tue, 05 Nov 2019 08:37:10 +0100

kdb (3.2.0-3) unstable; urgency=medium

  * Backport upstream commit 40cdaea4d7824cc1b0d26e6ad2dcb61fa2077911 to build
    with PostgreSQL 12+; patch
    upstream_PgSQL-driver-fix-build-with-PostgreSQL-12.patch.

 -- Pino Toscano <pino@debian.org>  Tue, 29 Oct 2019 08:10:39 +0100

kdb (3.2.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Update symbols file from logs of buildds.

 -- Pino Toscano <pino@debian.org>  Mon, 28 Oct 2019 22:47:37 +0100

kdb (3.2.0-1) experimental; urgency=medium

  * New upstream release.
  * libkdb3-4 had an ABI break with no SONAME bump, so:
    - apply the Debian ABI manager; patch enable_debianabimanager.diff
    - rename libkdb3-4 to libkdb3-4abi1
  * Update symbols files.
  * Update the patches:
    - upstream_cmake-find-PostgreSQL-11.patch: drop, backported from upstream
  * Backport upstream commit 6bba3130f8968abb2e904bda1e8b59f83dd43bdc to find
    PostgreSQL 12; patch upstream_cmake-find-PostgreSQL-12.patch.
  * Bump Standards-Version to 4.4.1, no changes required.
  * Add the configuration for the CI on salsa.

 -- Pino Toscano <pino@debian.org>  Sun, 27 Oct 2019 09:29:23 +0100

kdb (3.1.0-5) unstable; urgency=medium

  * Update symbols file from logs of buildds.
  * Use the pkgkde_symbolshelper dh addon, so "subst" symbols work properly.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Nov 2018 08:29:26 +0100

kdb (3.1.0-4) unstable; urgency=medium

  * Backport upstream commit 675d51d86b377992aacdb8253cb7c3b8a80474c0 to find
    PostgreSQL 11; patch upstream_cmake-find-PostgreSQL-11.patch.
    (Closes: #912115)
  * Update Vcs-* fields.
  * Bump Standards-Version to 4.2.1, no changes required.
  * Small update to the symbols file.

 -- Pino Toscano <pino@debian.org>  Sun, 04 Nov 2018 16:51:56 +0100

=== debian/control ===
Source: kdb
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake (>= 3.0),
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               extra-cmake-modules (>= 1.8.0),
               libicu-dev,
               libkf5coreaddons-dev (>= 5.16.0),
               libkf5i18n-dev (>= 5.16.0),
               libpq-dev,
               libsqlite3-dev,
               pkgconf,
               pkg-kde-tools (>= 0.15.16),
               postgresql-server-dev-all,
               python3:any,
               qtbase5-dev (>= 5.4.0),
               qttools5-dev,
Standards-Version: 4.7.2
Homepage: https://community.kde.org/KDb
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdb.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdb

Package: libkdb3-4abi1
X-Debian-ABI: 1
X-CMake-Target: KDb
Architecture: any
Multi-Arch: same
Depends: libkdb-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: database connectivity and creation framework -- shared library
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the shared library.
 .
 This package is part of the Calligra Suite.

Package: libkdb-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: data files for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the architecture independent data files for the
 KDb library and its drivers.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libkdb3-4abi1 (= ${binary:Version}),
         qtbase5-dev (>= 5.4.0),
         libkf5coreaddons-dev (>= 5.16.0),
         ${misc:Depends},
Description: development files for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the development files for KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-sqlite
Architecture: any
Depends: libkdb3-4abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SQLite driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for SQLite in KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-mysql
Architecture: any
Multi-Arch: same
Depends: libkdb3-4abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: MySQL driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for MySQL in KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-postgresql
Architecture: any
Multi-Arch: same
Depends: libkdb3-4abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: PostgreSQL driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for PostgreSQL in KDb.
 .
 This package is part of the Calligra Suite.

=== debian/rules ===
#!/usr/bin/make -f

DEFAULT_PGSQL_VERSION = $(lastword $(shell /usr/share/postgresql-common/supported-versions))

%:
	dh $@ --with kf5,pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DBUILD_TESTING=OFF \
		-DPython_ADDITIONAL_VERSIONS=3 \
		-DPostgreSQL_ADDITIONAL_VERSIONS=$(DEFAULT_PGSQL_VERSION)

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
https://download.kde.org/stable/kdb/src/@PACKAGE@-([\d.]+)\.tar\.xz

## kdb 3.2.0+p24.04+vunstable+git20251020.0212

=== debian/changelog ===
kdb (3.2.0+p24.04+vunstable+git20251020.0212-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 02:12:31 +0000

kdb (3.2.0-6.1) unstable; urgency=medium

  * CI: enable the blhc job again.
  * Bump Standards-Version to 4.6.1, no changes required.
  * Backport upstream commit 3a31ad05fcc7682bf3b65143af99fdb9b2e1e248 to fix the
    build with newer Qt 5.12.x; patch upstream_Fix-build-with-newer-Qt.patch.
    (Closes: #1013562)

 -- Pino Toscano <pino@debian.org>  Sun, 03 Jul 2022 07:49:01 +0200

kdb (3.1.0-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 11 Mar 2018 10:12:18 +0000

kdb (3.0.2-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 12 Aug 2017 06:12:05 +0000

kdb (3.0.1.1-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 13 Mar 2017 13:36:04 +0000

kdb (3.0.0-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 05 Oct 2016 11:38:37 +0000

## kdb 3.2.0+p24.04+vunstable+git20251111.0019

=== debian/changelog ===
kdb (3.2.0+p24.04+vunstable+git20251111.0019-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 00:19:18 +0000

## kdb 3.2.0+p24.04+vunstable+git20260105.1201

=== debian/changelog ===
kdb (3.2.0+p24.04+vunstable+git20260105.1201-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 05 Jan 2026 12:01:26 +0000

## kdb 3.2.0+p24.04+vunstable+git20260123.0228

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

# Dependencies
set(CMAKE_CXX_STANDARD 17)
set(REQUIRED_QT_VERSION 5.4.0)
set(REQUIRED_KF5_VERSION 5.45.0)

find_package(ECM ${REQUIRED_KF5_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
include(SetKDbCMakePolicies NO_POLICY_SCOPE)

project(KDb VERSION 3.2.90) # Update this: Alpha = 90, Beta 1 = 91, RC 1 = 94

include(KDbAddTests)
include(KDbAddExamples)
kdb_add_tests(OFF)
kdb_add_examples(OFF)

# ECM
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)

include(ECMGeneratePriFile)
include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)
include(ECMPoQmTools)
include(ECMSetupVersion)
include(ECMCoverageOption)
include(ECMSetupQtPluginMacroNames)
include(ECMAddQch)

# Own
include(KDbCreateSharedDataClasses)
include(KDbGenerateHeaders)
include(KDbMacros)

simple_option(BUILD_QCH "Build API documentation in QCH format" OFF)


# Required components to build this framework
# TODO move Widgets-dependent part to a libKDbWidgets
find_package(Qt5 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED Core Widgets Xml)
find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED CoreAddons)
find_package(ICU REQUIRED i18n uc)
set_package_properties(ICU PROPERTIES
                       PURPOSE "Required by KDb for unicode-aware string comparisons")

get_git_revision_and_branch()
add_unfinished_features_option()

add_subdirectory(src)
add_subdirectory(tools)

if(BUILD_TESTING)
  add_subdirectory(autotests)
  add_subdirectory(tests)
endif()

add_custom_target(cppclean
    COMMAND ${CMAKE_SOURCE_DIR}/tools/cppclean-kdb.sh ${CMAKE_BINARY_DIR}
    COMMENT "Running CPPCLEAN"
)

if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/poqm")
    ecm_install_po_files_as_qm(poqm)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -243,7 +243,7 @@
 endif()
 
 # Create a Config.cmake and a ConfigVersion.cmake file and install them
-set(CMAKECONFIG_INSTALL_DIR "${CMAKECONFIG_INSTALL_PREFIX}/${KDB_BASE_NAME}")
+set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/${KDB_BASE_NAME}")
 
 ecm_setup_version(${PROJECT_VERSION}
     VARIABLE_PREFIX KDB

=== src/drivers/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,13 @@
 
 #TODO  add_definitions(-DKDE_DEFAULT_DEBUG_AREA=44001)
 
-set(KDB_PLUGIN_INSTALL_DIR ${PLUGIN_INSTALL_DIR}/${KDB_BASE_NAME_LOWER})
+set(KDB_PLUGIN_INSTALL_DIR ${KDE_INSTALL_PLUGINDIR}/${KDB_BASE_NAME_LOWER})
+
+# Instruct automoc about C++ preprocessor macros used to define Qt-style plugins:
+ecm_setup_qtplugin_macro_names(
+    JSON_ARG2
+       KDB_DRIVER_PLUGIN_FACTORY
+)
 
 # -----------------------
 macro(build_and_install_kdb_driver _name _srcs _extra_libs)
@@ -28,7 +34,7 @@
 
 # find SQLite:
 set(SQLITE_MIN_VERSION 3.6.16)
-set(SQLITE_RECOMMENDED_VERSION 3.27.1)
+set(SQLITE_RECOMMENDED_VERSION 3.28.0)
 set(SQLITE_LOAD_EXTENSION_REQUIRED ON)
 set(BUILD_SQLITE_DB_DRIVER_DESC "SQLite database driver")
 find_package(Sqlite ${SQLITE_MIN_VERSION})

=== src/drivers/sqlite/dump/CMakeLists.txt ===
include(ECMMarkNonGuiExecutable)

set(kdb_sqlite_dump_tool_SRCS main.cpp shell.c README)

add_executable(${KDB_SQLITE_DUMP_TOOL} ${kdb_sqlite_dump_tool_SRCS})
ecm_mark_nongui_executable(${KDB_SQLITE_DUMP_TOOL})

target_link_libraries(${KDB_SQLITE_DUMP_TOOL}
    PRIVATE
        KDb
        ${SQLITE_LIBRARIES}
)
if(WIN32)
    set_target_properties(${KDB_SQLITE_DUMP_TOOL}
                          PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

install(TARGETS ${KDB_SQLITE_DUMP_TOOL} ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
kdb (3.2.0+p24.04+vunstable+git20260123.0228-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 23 Jan 2026 02:28:41 +0000

=== debian/control ===
--- 
+++ 
@@ -1,36 +1,39 @@
 Source: kdb
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: cmake (>= 3.0),
                debhelper-compat (= 13),
-               default-libmysqlclient-dev,
+               default-libmysqlclient-dev | libmysqlclient-dev,
                extra-cmake-modules (>= 1.8.0),
                libicu-dev,
                libkf5coreaddons-dev (>= 5.16.0),
                libkf5i18n-dev (>= 5.16.0),
                libpq-dev,
+               libpqxx-dev,
                libsqlite3-dev,
-               pkgconf,
+               pkg-config,
                pkg-kde-tools (>= 0.15.16),
                postgresql-server-dev-all,
                python3:any,
                qtbase5-dev (>= 5.4.0),
-               qttools5-dev,
-Standards-Version: 4.7.2
+               qttools5-dev
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Homepage: https://community.kde.org/KDb
-Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdb.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdb
+Vcs-Git: https://invent.kde.org/neon/extras/kdb.git
+Vcs-Browser: https://invent.kde.org/neon/extras/kdb
+Maintainer: Neon CI <neon@kde.org>
 
 Package: libkdb3-4abi1
 X-Debian-ABI: 1
 X-CMake-Target: KDb
 Architecture: any
 Multi-Arch: same
-Depends: libkdb-data (>= ${source:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: libkdb-data (>= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
+Conflicts: libkdb3-4abi1
+Breaks: libkdb3-4 (<< 3.2.0-6.1)
+Replaces: libkdb3-4 (<< 3.2.0-6.1)
 Description: database connectivity and creation framework -- shared library
  KDb is a database connectivity and creation framework, consisted of a
  general-purpose C++ Qt library and set of plugins delivering support
@@ -59,9 +62,9 @@
 Multi-Arch: same
 Section: libdevel
 Depends: libkdb3-4abi1 (= ${binary:Version}),
+         libkf5coreaddons-dev (>= 5.16.0),
          qtbase5-dev (>= 5.4.0),
-         libkf5coreaddons-dev (>= 5.16.0),
-         ${misc:Depends},
+         ${misc:Depends}
 Description: development files for KDb
  KDb is a database connectivity and creation framework, consisted of a
  general-purpose C++ Qt library and set of plugins delivering support
@@ -114,3 +117,16 @@
  This package contains the support for PostgreSQL in KDb.
  .
  This package is part of the Calligra Suite.
+
+Package: libkdb3-4
+Architecture: any
+Multi-Arch: same
+Depends: libkdb3-4abi1, ${misc:Depends}, ${shlibs:Depends}
+Priority: extra
+Section: oldlibs
+Description: transitional dummy
+ KDb is a database connectivity and creation framework, consisted of a
+ general-purpose C++ Qt library and set of plugins delivering support
+ for various database vendors.
+ .
+ This dummy package can be removed.
